package com.hungraim.ltc.governance.service.impl;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import com.hungraim.ltc.governance.dao.ChCfgAprItemClauseMapper;
import com.hungraim.ltc.governance.dao.ChCfgAprItemMapper;
import com.hungraim.ltc.governance.dao.ChCfgAprMapper;
import com.hungraim.ltc.governance.service.DisableAssessmentCriteriaService;
import com.hungraim.ltc.pojo.entity.assessment.ChCfgApr;
import com.hungraim.ltc.pojo.entity.assessment.ChCfgAprItem;
import com.hungraim.ltc.pojo.entity.assessment.ChCfgAprItemClause;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

/**
 * 失能评定标准service
 *
 * @author czz
 */
@Service
public class DisableAssessmentCriteriaServiceImpl implements DisableAssessmentCriteriaService {

    @Autowired
    private ChCfgAprMapper chCfgAprMapper;
    @Autowired
    private ChCfgAprItemMapper chCfgAprItemMapper;
    @Autowired
    private ChCfgAprItemClauseMapper chCfgAprItemClauseMapper;

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void addDisableAssessmentCriteria(String organId, String estimateName, String remark, Integer status, JSONArray project) {
        Date date = new Date();
        //鉴定标准配置
        ChCfgApr apr = new ChCfgApr();
        apr.setOrganId(organId);
        apr.setEstimateName(estimateName);
        apr.setRemark(remark);
        apr.setEffTime(date);
        apr.setStatus(status.shortValue());
        chCfgAprMapper.insert(apr);
        //鉴定项目定义
        for (int i = 0; i < project.size(); i++) {
            ChCfgAprItem item = new ChCfgAprItem();
            JSONObject itemObject = project.getJSONObject(i);
            String projectNama = itemObject.getStr("projectNama");
            String minVal = itemObject.getStr("minVal");
            String maxVal = itemObject.getStr("maxVal");
            item.setItemName(projectNama);
            item.setMinValue(Short.parseShort(minVal));
            item.setMaxValue(Short.parseShort(maxVal));
            item.setAprId(apr.getAprId());
            chCfgAprItemMapper.insert(item);

            //鉴定项目定义明细
            JSONArray projectScoreCriteria = itemObject.getJSONArray("projectScoreCriteria");
            for (int j = 0; j < projectScoreCriteria.size(); j++) {
                ChCfgAprItemClause clause = new ChCfgAprItemClause();
                JSONObject clauseObject = projectScoreCriteria.getJSONObject(j);
                String criteria = clauseObject.getStr("criteria");
                String reference = clauseObject.getStr("reference");
                clause.setClauseDesc(criteria);
                clause.setClauseValue(Short.parseShort(reference));
                clause.setItemId(item.getItemId());
                clause.setAprId(apr.getAprId());
                chCfgAprItemClauseMapper.insert(clause);
            }
        }

    }
}
